       IDENTIFICATION DIVISION.
       PROGRAM-ID.    CBLVLRC4.
      *AUTHOR.        SIMOTIME TECHNOLOGIES.
      *****************************************************************
      * Source Member: CBLVLRC4.CBL
      * Copy Files:    PASSBSIO.CPY
      *                ASCEBCB1.CPY
      * Calls to:      SIMOBSIO
      *****************************************************************
      *
      *                   ************
      *                   * CBLVLRE1 *
      *                   ********cmd*
      *                        *
      *                   ************
      *                   * if exist  *
      *                   ********stmt*
      *                        *
      *  ************     ************     ************
      *  * ALPHAV01 *-----* CBLVLRC4 *-----* BSIODSN2 *
      *  ********dat*     ********cbl*     ********dat*
      *                        *   *
      *                        *   *       ************
      *                        *   *-call--* SIMOBSIO *
      *                        *           ********cbl*
      *                        *
      *                   ************
      *                   *   EOJ    *
      *                   ************
      *
      *****************************************************************
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           SELECT ALPHAV01-FILE ASSIGN to ALPHAV01
                          ORGANIZATION is SEQUENTIAL
                          ACCESS MODE  is SEQUENTIAL
                          FILE STATUS  is ALPHAV01-STATUS.

      *****************************************************************
       DATA DIVISION.
       FILE SECTION.
       FD  ALPHAV01-FILE
           DATA RECORD    is ALPHAV01-RECORD
           RECORDING MODE is V
           RECORD is VARYING in SIZE from 4 to 32760
           depending on ALPHAV01-LREC.

       01  ALPHAV01-RECORD.
           05  ALPHAV01-DATA-01  pic X(32760).

       WORKING-STORAGE SECTION.
       01  SIM-TITLE.
           05  T1 pic X(11) value '* CBLVLRC4 '.
           05  T2 pic X(34) value 'RSEQ-V-4-32760-E to BSIO-4-32760-E'.
           05  T3 pic X(10) value ' v08.03.09'.
           05  T4 pic X(24) value ' http://www.simotime.com'.
       01  SIM-COPYRIGHT.
           05  C1 pic X(11) value '* CBLVLRC4 '.
           05  C2 pic X(20) value 'Copyright 1987-2018 '.
           05  C3 pic X(28) value '    SimoTime Technologies   '.
           05  C4 pic X(20) value ' All Rights Reserved'.

       01  SIM-THANKS-01.
           05  C1 pic X(11) value '* CBLVLRC4 '.
           05  C2 pic X(32) value 'Thank you for using this sample '.
           05  C3 pic X(32) value 'by   SimoTime Technologies      '.
           05  C4 pic X(04) value '    '.

       01  SIM-THANKS-02.
           05  C1 pic X(11) value '* CBLVLRC4 '.
           05  C2 pic X(32) value 'Please send comments or suggesti'.
           05  C3 pic X(32) value 'ons to helpdesk@simotime.com    '.
           05  C4 pic X(04) value '    '.


       01  MESSAGE-BUFFER.
           05  MESSAGE-HEADER      pic X(11)   value '* CBLVLRC4 '.
           05  MESSAGE-TEXT.
               10  MESSAGE-TEXT-1  pic X(68)   value SPACES.
               10  MESSAGE-TEXT-2  pic X(188)  value SPACES.

       01  ALPHAV01-STATUS.
           05  ALPHAV01-STATUS-L     pic X.
           05  ALPHAV01-STATUS-R     pic X.
       01  ALPHAV01-EOF              pic X       value 'N'.
       01  ALPHAV01-OPEN-FLAG        pic X       value 'C'.

       01  IO-STATUS.
           05  IO-STAT1            pic X.
           05  IO-STAT2            pic X.
       01  TWO-BYTES.
           05  TWO-BYTES-LEFT      pic X.
           05  TWO-BYTES-RIGHT     pic X.
       01  TWO-BYTES-BINARY        redefines TWO-BYTES pic 9(4) comp.

      *****************************************************************
      *    Data-structure for environment variable get routine...     *
      *****************************************************************
       01  ENV-VAR-NAME            pic X(16)   value SPACES.
       01  ENV-VAR-VALUE           pic X(256)  value SPACES.

       01  APPL-RESULT             pic S9(9)   comp.
           88  APPL-AOK            value 0.
           88  APPL-EOF            value 16.

       01  DEBUG-LEVEL             pic 9(2)    value 2.

       01  TEXT-LENGTH             pic 9(5)    value 0.

       01  ALPHAV01-LREC           pic 9(5)    comp    value 0.

       01  VARIABLE-RECORD-HEADER.
           05  VREC-HDR-1          pic 9(3)    COMP VALUE 0.
           05  VREC-HDR-2          pic 9(3)    COMP VALUE 0.

       01  RECORD-LENGTH-DISPLAY.
           05  filler              pic X(15) value 'Record length: '.
           05  RECORD-LENGTH-VALUE pic 9(5)  value 0.

       01  RECORD-MIN-DISPLAY.
           05  filler              pic X(15) value 'Record MIN is: '.
           05  RECORD-MIN-VALUE    pic 9(4)  value 0.

       01  RECORD-MAX-DISPLAY.
           05  filler              pic X(15) value 'Record MAX is: '.
           05  RECORD-MAX-VALUE    pic 9(4)  value 0.

       01  BSIOPUT1-TOTAL.
           05  filler      pic X(23)  value 'FTEDBV02 line count is '.
           05  BSIOPUT1-COUNT      pic 9(7) value 0.

       01  ALPHAV01-TOTAL.
           05  filler      pic X(23)  value 'ALPHAV01 line count is '.
           05  ALPHAV01-LOC        pic 9(7) value 0.

      *****************************************************************
      * The following copy file is the pass area for calling SIMOBSIO,
      * the byte stream I/O routine.
      *****************************************************************
      *
       COPY PASSBSIO.
      *
      *****************************************************************
      * The following copy file is the ASCII and EBCDIC conversion
      * tables. The tables may also be used UPPER/lower case converts.
      *****************************************************************
       COPY ASCEBCB1.
      *
      *****************************************************************
       PROCEDURE DIVISION.
           perform Z-POST-COPYRIGHT
           move SPACES     to ENV-VAR-NAME
           move 'BSIODSN2' to ENV-VAR-NAME
           perform GET-ENVIRONMENT-VARIABLE
           if  ENV-VAR-VALUE not = SPACES
               move ENV-VAR-VALUE to PSIO-FILENAME
           else
               move 'Invalid file name for BSIO Function'
                 to MESSAGE-TEXT
               perform Z-ABEND-PROGRAM
           end-if
           add 80 to zero giving PSIO-MAX-SIZE

           perform ALPHAV01-OPEN
           perform BSIO-OPEN-PUT

           perform BSIO-PUT-VREC4

           perform BSIO-CLOSE
           perform ALPHAV01-CLOSE

           move BSIOPUT1-TOTAL to MESSAGE-TEXT
           perform Z-DISPLAY-CONSOLE-MESSAGE
           perform Z-THANK-YOU.
           GOBACK.

      *****************************************************************
      * I/O ROUTINES FOR BYTE-Stream I/O...                           *
      *****************************************************************
       BSIO-PUT-VREC4.
           move ZERO to PSIO-OFFSET
           move 'WRITE   ' to PSIO-REQUEST
           perform until ALPHAV01-STATUS not = '00'
             perform ALPHAV01-READ
             if  ALPHAV01-STATUS = '00'
                 perform CALCULATE-STRING-LENGTH
                 add TEXT-LENGTH to 4 giving VREC-HDR-1
                 move VARIABLE-RECORD-HEADER to PSIO-BUFFER(1:4)
                 move ALPHAV01-RECORD to PSIO-BUFFER(5:TEXT-LENGTH)
                 add TEXT-LENGTH to 4 giving PSIO-LENGTH
                 call 'SIMOBSIO' using PSIO-PASS-AREA
                 add PSIO-LENGTH to PSIO-OFFSET
                 add 1 to BSIOPUT1-COUNT
             end-if
           end-perform
           exit.

      *---------------------------------------------------------------*
       BSIO-OPEN-PUT.
           move 'CREATE  ' to PSIO-REQUEST
           call 'SIMOBSIO' using PSIO-PASS-AREA
      *    move 'OPENPUT ' to PSIO-REQUEST
      *    call 'SIMOBSIO' using PSIO-PASS-AREA

           move PSIO-FILENAME to MESSAGE-TEXT
           perform Z-DISPLAY-CONSOLE-MESSAGE

           if  PSIO-RETURN = 0
               move 'AOK, OPEN Input File for BSIO'  to MESSAGE-TEXT
           else
               move 'NOK, OPEN Input File FAILURE '  to MESSAGE-TEXT
               perform Z-ABEND-PROGRAM
           end-if
           perform Z-DISPLAY-CONSOLE-MESSAGE
           exit.

      *---------------------------------------------------------------*
       BSIO-CLOSE.
           move 'FILEINFO' to PSIO-REQUEST
           call 'SIMOBSIO' using PSIO-PASS-AREA

           if  PSIO-RETURN = 0
               move 'AOK, File Info Request for BSIO'  to MESSAGE-TEXT
               perform Z-DISPLAY-CONSOLE-MESSAGE
               move PSIO-FILE-SIZE to MESSAGE-TEXT
               perform Z-DISPLAY-CONSOLE-MESSAGE
           else
               move 'NOK, File Info Request FAILURE '  to MESSAGE-TEXT
               perform Z-ABEND-PROGRAM
           end-if

           move 'CLOSE   ' to PSIO-REQUEST
           call 'SIMOBSIO' using PSIO-PASS-AREA
           exit.

      *****************************************************************
       CALCULATE-STRING-LENGTH.
           add 80 to ZERO giving TEXT-LENGTH
      *    if  ALPHAV01-RECORD(513:512) = all X'40'
      *        if  ALPHAV01-RECORD(257:768) = all X'40'
      *            add 256 to ZERO giving TEXT-LENGTH
      *        else
      *            add 512 to ZERO giving TEXT-LENGTH
      *        end-if
      *    else
      *        if  ALPHAV01-RECORD(769:256) = all X'40'
      *            add 768 to ZERO giving TEXT-LENGTH
      *        end-if
      *    end-if

           perform until TEXT-LENGTH = 0
                      or ALPHAV01-RECORD(TEXT-LENGTH:1) not = X'40'
               if  ALPHAV01-RECORD(TEXT-LENGTH:1) = X'40'
                   subtract 1 from TEXT-LENGTH
               end-if
           end-perform
           exit.

      *****************************************************************
      * Get an environment variable.                                  *
      *****************************************************************
       GET-ENVIRONMENT-VARIABLE.
           move SPACES to ENV-VAR-VALUE
           accept  ENV-VAR-VALUE from ENVIRONMENT ENV-VAR-NAME
                   on exception add 8 to ZERO giving RETURN-CODE
           end-accept
           if  RETURN-CODE not = 0
               move SPACES to ENV-VAR-VALUE
           end-if
           exit.

      *****************************************************************
      * I/O ROUTINES FOR ALPHAV01...                                  *
      *****************************************************************
       ALPHAV01-CLOSE.
           add 8 to ZERO giving APPL-RESULT.
           close ALPHAV01-FILE
           if  ALPHAV01-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'ALPHAV01-Failure-CLOSE...' to MESSAGE-TEXT
               perform Z-DISPLAY-CONSOLE-MESSAGE
               move ALPHAV01-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       ALPHAV01-READ.
           move all x'40' to ALPHAV01-RECORD
           read ALPHAV01-FILE
           if  ALPHAV01-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               if  ALPHAV01-STATUS = '10'
                   add 16 to ZERO giving APPL-RESULT
               else
                   add 12 to ZERO giving APPL-RESULT
               end-if
           end-if
           if  APPL-AOK
               CONTINUE
           else
               if  APPL-EOF
                   move 'Y' to ALPHAV01-EOF
               else
                   move 'ALPHAV01-Failure-GET...' to MESSAGE-TEXT
                   perform Z-DISPLAY-CONSOLE-MESSAGE
                   move ALPHAV01-STATUS to IO-STATUS
                   perform Z-DISPLAY-IO-STATUS
                   perform Z-ABEND-PROGRAM
               end-if
           end-if
           exit.
      *---------------------------------------------------------------*
       ALPHAV01-OPEN.
           add 8 to ZERO giving APPL-RESULT.
           open input ALPHAV01-FILE
           if  ALPHAV01-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'O' to ALPHAV01-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'ALPHAV01-Failure-OPEN...' to MESSAGE-TEXT
               perform Z-DISPLAY-CONSOLE-MESSAGE
               move ALPHAV01-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.

      *****************************************************************
      * The following Z-Routines perform administrative tasks         *
      * for this program.                                             *
      *****************************************************************
      * ABEND the program, post a message to the console and issue    *
      * a STOP RUN.                                                   *
      *****************************************************************
       Z-ABEND-PROGRAM.
           if  MESSAGE-TEXT not = SPACES
               perform Z-DISPLAY-CONSOLE-MESSAGE
           end-if
           move 'PROGRAM-IS-ABENDING...'  to MESSAGE-TEXT
           perform Z-DISPLAY-CONSOLE-MESSAGE
           add 12 to ZERO giving RETURN-CODE
           STOP RUN.
      *    exit.

      *****************************************************************
      * Display CONSOLE messages...                                   *
      *****************************************************************
       Z-DISPLAY-CONSOLE-MESSAGE.
           if MESSAGE-TEXT-2 = SPACES
               display MESSAGE-BUFFER(1:79)
           else
               display MESSAGE-BUFFER
           end-if
           move all SPACES to MESSAGE-TEXT
           exit.

      *****************************************************************
      * Display the file status bytes. This routine will display as   *
      * two digits if the full two byte file status is numeric. If    *
      * second byte is non-numeric then it will be treated as a       *
      * binary number.                                                *
      *****************************************************************
       Z-DISPLAY-IO-STATUS.
           if  IO-STATUS not NUMERIC
           or  IO-STAT1    = '9'
               subtract TWO-BYTES-BINARY from TWO-BYTES-BINARY
               move IO-STAT2 to TWO-BYTES-RIGHT
               display '* CBLVLRC4 File-Status-' IO-STAT1 '/'
                       TWO-BYTES-BINARY
           else
               display '* CBLVLRC4 File-Status-' IO-STATUS
           end-if
           exit.

      *****************************************************************
       Z-POST-COPYRIGHT.
           display SIM-TITLE
           display SIM-COPYRIGHT
           exit.

      *****************************************************************
       Z-THANK-YOU.
           display SIM-THANKS-01
           display SIM-THANKS-02
           exit.
      *****************************************************************
      *      This example is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *****************************************************************
