       IDENTIFICATION DIVISION.
       PROGRAM-ID.    CBLVLRC5.
      *AUTHOR.        SIMOTIME TECHNOLOGIES.
      *****************************************************************
      * Source Member: CBLVLRC5.CBL
      * Copy Files:    PASSRTN1.CPY
      *                ASCEBCB1.CPY
      * Calls to:      SIMOBSIO
      *****************************************************************
      *
      *                   ************
      *                   * CBLVLRC5 *
      *                   ********cmd*
      *                        *
      *                   ************
      *                   * if exist  *
      *                   ********stmt*
      *                        *
      *  ************     ************     ************
      *  * BSIODSN2 *-----* CBLVLRC5 *-----* ALPHARS2 *
      *  ********dat*     ********cbl*     ********dat*
      *                     *  *
      *  ************       *  *
      *  * SIMOBSIO *--call-*  *
      *  ********cbl*          *
      *                        *
      *                   ************
      *                   *   EOJ    *
      *                   ************
      *
      *****************************************************************
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           SELECT ALPHARS2-FILE ASSIGN to ALPHARS2
                          ORGANIZATION is SEQUENTIAL
                           ACCESS MODE is SEQUENTIAL
                           FILE STATUS is ALPHARS2-STATUS.

      *****************************************************************
       DATA DIVISION.
       FILE SECTION.
       FD  ALPHARS2-FILE
           DATA RECORD    is ALPHARS2-RECORD.

       01  ALPHARS2-RECORD.
           05  ALPHARS2-DATA-01  pic X(80).

       WORKING-STORAGE SECTION.
       01  SIM-TITLE.
           05  T1 pic X(11) value '* CBLVLRC5 '.
           05  T2 pic X(34) value 'BSIO-V-4-32760-E to RESQ-F-80-E   '.
           05  T3 pic X(10) value ' v08.03.09'.
           05  T4 pic X(24) value ' http://www.simotime.com'.
       01  SIM-COPYRIGHT.
           05  C1 pic X(11) value '* CBLVLRC5 '.
           05  C2 pic X(20) value 'Copyright 1987-2018 '.
           05  C3 pic X(28) value '    SimoTime Technologies   '.
           05  C4 pic X(20) value ' All Rights Reserved'.

       01  SIM-THANKS-01.
           05  C1 pic X(11) value '* CBLVLRC5 '.
           05  C2 pic X(32) value 'Thank you for using this sample '.
           05  C3 pic X(32) value 'by   SimoTime Technologies      '.
           05  C4 pic X(04) value '    '.

       01  SIM-THANKS-02.
           05  C1 pic X(11) value '* CBLVLRC5 '.
           05  C2 pic X(32) value 'Please send comments or suggesti'.
           05  C3 pic X(32) value 'ons to helpdesk@simotime.com    '.
           05  C4 pic X(04) value '    '.

       01  MESSAGE-BUFFER.
           05  MESSAGE-HEADER      pic X(11)   value '* CBLVLRC5 '.
           05  MESSAGE-TEXT.
               10  MESSAGE-TEXT-1  pic X(68)   value SPACES.
               10  MESSAGE-TEXT-2  pic X(188)  value SPACES.

       01  ALPHARS2-STATUS.
           05  ALPHARS2-STATUS-L     pic X.
           05  ALPHARS2-STATUS-R     pic X.
       01  ALPHARS2-EOF              pic X       value 'N'.
       01  ALPHARS2-OPEN-FLAG        pic X       value 'C'.

       01  IO-STATUS.
           05  IO-STAT1            pic X.
           05  IO-STAT2            pic X.
       01  TWO-BYTES.
           05  TWO-BYTES-LEFT      pic X.
           05  TWO-BYTES-RIGHT     pic X.
       01  TWO-BYTES-BINARY        redefines TWO-BYTES pic 9(4) comp.

      *****************************************************************
      *    Data-structure for environment variable get routine...     *
      *****************************************************************
       01  ENV-VAR-NAME            pic X(16)   value SPACES.
       01  ENV-VAR-VALUE           pic X(256)  value SPACES.

       01  APPL-RESULT             pic S9(9)   comp.
           88  APPL-AOK            value 0.
           88  APPL-EOF            value 16.

       01  DEBUG-LEVEL             pic 9(2)    value 0.

       01  ALPHARS2-LREC           pic 9(5)    comp    value 0.
       01  ALPHARS2-LREC-ALPHA     redefines   ALPHARS2-LREC.
           05  VREC-LEN-1          pic X(2).
           05  VREC-LEN-2          pic X(2).

       01  RECORD-LENGTH-DISPLAY.
           05  filler              pic X(15) value 'Record length: '.
           05  RECORD-LENGTH-VALUE pic 9(5)  value 0.

       01  RECORD-MIN-DISPLAY.
           05  filler              pic X(15) value 'Record MIN is: '.
           05  RECORD-MIN-VALUE    pic 9(4)  value 0.

       01  RECORD-MAX-DISPLAY.
           05  filler              pic X(15) value 'Record MAX is: '.
           05  RECORD-MAX-VALUE    pic 9(4)  value 0.

       01  BSIOREAD-TOTAL.
           05  filler      pic X(23)  value 'BSIOREAD line count is '.
           05  BSIOREAD-COUNT      pic 9(7) value 0.

       01  PGM1GET1-TOTAL.
           05  filler      pic X(23)  value 'PGM1GET1 line count is '.
           05  PGM1GET1-LOC        pic 9(7) value 0.

      *****************************************************************
      * The following copy file is the pass area for calling SIMOBSIO,
      * the byte stream I/O routine.
      *****************************************************************
      *
       COPY PASSBSIO.
      *
      *****************************************************************
      * The following copy file is the ASCII and EBCDIC conversion
      * tables. The tables may also be used UPPER/lower case converts.
      *****************************************************************
       COPY ASCEBCB1.
      *
      *****************************************************************
       PROCEDURE DIVISION.
           perform Z-POST-COPYRIGHT
           move SPACES     to ENV-VAR-NAME
           move 'BSIODSN2' to ENV-VAR-NAME
           perform GET-ENVIRONMENT-VARIABLE
           if  ENV-VAR-VALUE not = SPACES
               move ENV-VAR-VALUE to PSIO-FILENAME
           else
               move 'Invalid file name for BSIO Function'
                 to MESSAGE-TEXT
               perform Z-ABEND-PROGRAM
           end-if
           add 80 to zero giving PSIO-MAX-SIZE

           perform ALPHARS2-OPEN
           perform BSIO-OPEN

           perform BSIO-READ-VREC4

           perform BSIO-CLOSE
           perform ALPHARS2-CLOSE

           move BSIOREAD-TOTAL to MESSAGE-TEXT
           perform Z-DISPLAY-CONSOLE-MESSAGE
           perform Z-THANK-YOU.
           GOBACK.

      *****************************************************************
      * I/O ROUTINES FOR BYTE-Stream I/O...                           *
      *****************************************************************
       BSIO-READ-VREC4.
           move ZERO to PSIO-OFFSET
           perform until PSIO-OFFSET not < PSIO-FILE-SIZE
      *!     Get the first four bytes as the record length
             add 4 to ZERO giving PSIO-LENGTH
             move 'READBSIO' to PSIO-REQUEST
             call 'SIMOBSIO' using PSIO-PASS-AREA
             move PSIO-BUFFER(1:2) to ALPHARS2-LREC-ALPHA(3:2)
             subtract 4 from  ALPHARS2-LREC

             if  DEBUG-LEVEL > 1
                 add ALPHARS2-LREC to ZERO giving RECORD-LENGTH-VALUE
                 move RECORD-LENGTH-DISPLAY to MESSAGE-TEXT
                 perform Z-DISPLAY-CONSOLE-MESSAGE
             end-if

      *!     Read the variable-length record.
             add PSIO-LENGTH to PSIO-OFFSET
             add  ALPHARS2-LREC to ZERO giving PSIO-LENGTH

             if  PSIO-LENGTH > PSIO-MAX-SIZE
                 add PSIO-MAX-SIZE to ZERO giving ALPHARS2-LREC
                 display 'Block read size exceeds max size '
                         PSIO-LENGTH ' vs ' PSIO-MAX-SIZE
                         ' Record Number is ' BSIOREAD-COUNT
                         upon console
             end-if

             call 'SIMOBSIO' using PSIO-PASS-AREA

             move all x'40' to ALPHARS2-RECORD
      *      move all SPACES to ALPHARS2-RECORD
      *      inspect PSIO-BUFFER(1:ALPHARS2-LREC)
      *              converting EBCDIC-INFO
      *                      to ASCII-INFO
             move PSIO-BUFFER(1:ALPHARS2-LREC)
               to ALPHARS2-RECORD(1:ALPHARS2-LREC)

             if  DEBUG-LEVEL > 1
                 move ALPHARS2-RECORD to MESSAGE-TEXT
                 perform Z-DISPLAY-CONSOLE-MESSAGE
             end-if

             perform ALPHARS2-WRITE

             add 1 to BSIOREAD-COUNT
             add PSIO-LENGTH to PSIO-OFFSET
      *!     The following is only needed to increment past the
      *!     CR/LF when using ASCII/Text Files created in a Windows
      *!     environment.
      *      add 2 to PSIO-OFFSET
           end-perform

           exit.

      *---------------------------------------------------------------*
       BSIO-OPEN.
           move 'OPEN    ' to PSIO-REQUEST
           call 'SIMOBSIO' using PSIO-PASS-AREA

           move PSIO-FILENAME to MESSAGE-TEXT
           perform Z-DISPLAY-CONSOLE-MESSAGE

           if  PSIO-RETURN = 0
               move 'AOK, OPEN Input File for BSIO'  to MESSAGE-TEXT
           else
               move 'NOK, OPEN Input File FAILURE '  to MESSAGE-TEXT
               perform Z-ABEND-PROGRAM
           end-if
           perform Z-DISPLAY-CONSOLE-MESSAGE

           move 'FILEINFO' to PSIO-REQUEST
           call 'SIMOBSIO' using PSIO-PASS-AREA

           if  PSIO-RETURN = 0
               move 'AOK, File Info Request for BSIO'  to MESSAGE-TEXT
               perform Z-DISPLAY-CONSOLE-MESSAGE
               move PSIO-FILE-SIZE to MESSAGE-TEXT
               perform Z-DISPLAY-CONSOLE-MESSAGE
           else
               move 'NOK, File Info Request FAILURE '  to MESSAGE-TEXT
               perform Z-ABEND-PROGRAM
           end-if

           exit.

      *---------------------------------------------------------------*
       BSIO-CLOSE.
           move 'CLOSE   ' to PSIO-REQUEST
           call 'SIMOBSIO' using PSIO-PASS-AREA
           exit.

      *****************************************************************
      * Get an environment variable.                                  *
      *****************************************************************
       GET-ENVIRONMENT-VARIABLE.
           move SPACES to ENV-VAR-VALUE
           accept  ENV-VAR-VALUE from ENVIRONMENT ENV-VAR-NAME
                   on exception add 8 to ZERO giving RETURN-CODE
           end-accept
           if  RETURN-CODE not = 0
               move SPACES to ENV-VAR-VALUE
           end-if
           exit.

      *****************************************************************
      * I/O ROUTINES FOR ALPHARS2...                                  *
      *****************************************************************
       ALPHARS2-WRITE.
           if  ALPHARS2-OPEN-FLAG = 'C'
               perform ALPHARS2-OPEN
           end-if
           write ALPHARS2-RECORD
           if  ALPHARS2-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               if  ALPHARS2-STATUS = '10'
                   add 16 to ZERO giving APPL-RESULT
               else
                   add 12 to ZERO giving APPL-RESULT
               end-if
           end-if.
           if  APPL-AOK
               CONTINUE
           else
               move 'ALPHARS2-Failure-WRITE...' to MESSAGE-TEXT
               perform Z-DISPLAY-CONSOLE-MESSAGE
               move ALPHARS2-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       ALPHARS2-OPEN.
           add 8 to ZERO giving APPL-RESULT.
           open output ALPHARS2-FILE
           if  ALPHARS2-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'O' to ALPHARS2-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'ALPHARS2-Failure-OPEN...' to MESSAGE-TEXT
               perform Z-DISPLAY-CONSOLE-MESSAGE
               move ALPHARS2-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       ALPHARS2-CLOSE.
           add 8 to ZERO giving APPL-RESULT.
           close ALPHARS2-FILE
           if  ALPHARS2-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'C' to ALPHARS2-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'ALPHARS2-Failure-CLOSE...' to MESSAGE-TEXT
               perform Z-DISPLAY-CONSOLE-MESSAGE
               move ALPHARS2-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.

      *****************************************************************
      * The following Z-Routines perform administrative tasks         *
      * for this program.                                             *
      *****************************************************************
      * ABEND the program, post a message to the console and issue    *
      * a STOP RUN.                                                   *
      *****************************************************************
       Z-ABEND-PROGRAM.
           if  MESSAGE-TEXT not = SPACES
               perform Z-DISPLAY-CONSOLE-MESSAGE
           end-if
           move 'PROGRAM-IS-ABENDING...'  to MESSAGE-TEXT
           perform Z-DISPLAY-CONSOLE-MESSAGE
           add 12 to ZERO giving RETURN-CODE
           STOP RUN.
      *    exit.

      *****************************************************************
      * Display CONSOLE messages...                                   *
      *****************************************************************
       Z-DISPLAY-CONSOLE-MESSAGE.
           if MESSAGE-TEXT-2 = SPACES
               display MESSAGE-BUFFER(1:79)
           else
               display MESSAGE-BUFFER
           end-if
           move all SPACES to MESSAGE-TEXT
           exit.

      *****************************************************************
      * Display the file status bytes. This routine will display as   *
      * two digits if the full two byte file status is numeric. If    *
      * second byte is non-numeric then it will be treated as a       *
      * binary number.                                                *
      *****************************************************************
       Z-DISPLAY-IO-STATUS.
           if  IO-STATUS not NUMERIC
           or  IO-STAT1    = '9'
               subtract TWO-BYTES-BINARY from TWO-BYTES-BINARY
               move IO-STAT2 to TWO-BYTES-RIGHT
               display '* CBLVLRC5 File-Status-' IO-STAT1 '/'
                       TWO-BYTES-BINARY
           else
               display '* CBLVLRC5 File-Status-' IO-STATUS
           end-if
           exit.

      *****************************************************************
       Z-POST-COPYRIGHT.
           display SIM-TITLE
           display SIM-COPYRIGHT
           exit.

      *****************************************************************
       Z-THANK-YOU.
           display SIM-THANKS-01
           display SIM-THANKS-02
           exit.
      *****************************************************************
      *      This example is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *****************************************************************
